#region usings 
using System;
using System.Net;
using System.Text;
using VVVV.PluginInterfaces.V2;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "PostToWall", Category = "Facebook", Help = "Post to Wall", Author = "tgd")]
	#endregion PluginInfo
	public class FacebookPostToWallNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Post", IsBang=true, IsSingle=true)]
        ISpread<bool> FBang;
		
		[Input("Post Text", IsSingle=true)]
		ISpread<string> FPostText;
		
		[Input("Optional Fields")]
		ISpread<string> FOptionalFields;
		
		[Input("Access Token", IsSingle=true)]
		ISpread<string> FAccessToken;
		
		[Output("PostID")]
		ISpread<string> FResponse;
		#endregion fields & pins

		//call to facebook
		public void Evaluate(int SpreadMax)
		{
			if (FBang[0]) 
			try {
	
		string theURL = "https://graph.facebook.com/me/feed";	
				
		byte[] dataToPost = Encoding.UTF8.GetBytes
		( "message=" + FPostText[0] + 
		  "&link=" + FOptionalFields[0] +
		  "&name=" + FOptionalFields[1] + 
		  "&caption=" + FOptionalFields[2] +
		  "&description=" + FOptionalFields[3] +
		  "&picture=" + FOptionalFields[4] + 
		  "&access_token=" + FAccessToken[0] );
		
		WebClient myWebClient = new WebClient();
		myWebClient.UploadDataCompleted += new UploadDataCompletedEventHandler(Complete);
		myWebClient.UploadDataAsync(new Uri (theURL), dataToPost);
				
		 		} catch (Exception error) {FResponse[0] = error.Message;} 
		}
		
		
		//output response from facebook
		public void Complete(object sender, UploadDataCompletedEventArgs e)
		{            
  	        try {
 			
  	        	string theResponse = Encoding.UTF8.GetString(e.Result); // response byte to string
  		    
  	        	theResponse = theResponse.Remove(0,7); 
  	        	theResponse = theResponse.Remove((theResponse.Length-2),2);
								
				FResponse[0] = theResponse;
				        	
  	           } catch (Exception error) {FResponse[0] = error.Message;} 
		}		
		
		
		
	}
}
