#region usings 
using System;
using System.Net;
using System.Text;
using System.Collections.Generic;
using VVVV.PluginInterfaces.V2;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "ReadAlbums", Category = "Facebook", Help = "List user´s albums", Tags = "tgd")]
	#endregion PluginInfo
	public class FacebookReadAlbumsNode : IPluginEvaluate
	{
#region fields & pins
		[Input("Read", IsBang=true, IsSingle=true)]
        ISpread<bool> FBang;
		
		[Input("Access Token", IsSingle=true)]
		ISpread<string> FAccessToken;
		
		[Output("Album Count")]
		ISpread<int> FAlbumCount;
		
		[Output("Photo Count")]
		ISpread<int> FPhotoCount;
		
		[Output("IDs")]
		ISpread<string> FAlbumID;
		
		[Output("Names")]
		ISpread<string> FName;
		
		#endregion fields & pins

		 
		//call to facebook
		public void Evaluate(int SpreadMax)
		{
			if (FBang[0]) 
			
			
			
			try {
	
				
		string theURL = ("https://graph.facebook.com/me/albums/?access_token=" + FAccessToken[0] + "&limit=1000");
		
		WebClient myWebClient = new WebClient();
		myWebClient.DownloadDataCompleted += new DownloadDataCompletedEventHandler(Complete);
		myWebClient.DownloadDataAsync(new Uri (theURL));
				
		 		} catch (Exception error) {FName[0] = error.Message;} // debug
		}
		
		
		//output response from facebook
		public void Complete(object sender, DownloadDataCompletedEventArgs e)
		{            
  	        try {
 			
  	        string theResponse = Encoding.UTF8.GetString(e.Result); // response byte to string
  		    
  	        List<string> listResp = new List<string>(theResponse.Split(','));  // split response to slices (new List)
			  	        	
  	        	//repair empty albums//
  	        	       	        	
  	        	for (int x = 0; x < (listResp.Count); x++)  
			{
    			if(listResp[x].Contains("{\"id\"")) 
   				 if(listResp[x+8].Contains("count"))  
					{ }     						
					  else 	 						
						{											
						listResp.Insert((x+7), "--------0");    
   						listResp.Insert((x+6), "loremipsum");   
						}
   			}	
  	              	        	
  	        	//create output spreads// 	 
				List<string> listIDs = new List<string>(); 
				List<string> listPhotoCount = new List<string>(); 		
  	      		List<string> listNames = new List<string>(); 	
  	        	
  	        	  	        	
  	        	//format response and fill the lists//
  	        	listResp[0] = listResp[0].Remove(0,9); 
  	        	
				for (int i = 0; i < (listResp.Count); i++)	 
			{
    			if(listResp[i].Contains("{\"id\""))      
   				{										       	
   					
   				listResp[i] = listResp[i].Remove(0,7); 	
				listResp[i] = listResp[i].Remove((listResp[i].Length-1),1);
				  listIDs.Add(listResp[i]); 	
   				
   				listResp[i+4] = listResp[i+4].Remove(0,8); 
   				listResp[i+4] = listResp[i+4].Remove((listResp[i+4].Length-1),1); 
   				  listNames.Add(listResp[i+4]); 	
   				
   				listResp[i+8] = listResp[i+8].Remove(0,8); 
   				  listPhotoCount.Add(listResp[i+8]); 	
   					
   		
   					
   				}
			}
  	              	 	  
  	        	//output//
  	        	int[] listPhotoCountInt = Array.ConvertAll<string, int> 
				(listPhotoCount.ToArray(), new Converter<string, int>(Convert.ToInt32)); 
  	        	
  	        	FPhotoCount.SliceCount = listIDs.Count;
    			FAlbumID.SliceCount = listIDs.Count;
				FName.SliceCount = listIDs.Count;
  	        	
  	        	FAlbumCount[0] = listIDs.Count;
  	        	
  	        	for (int j = 0; j < (listIDs.Count); j++)
			{
       			
				FPhotoCount[j] = listPhotoCountInt[j];
				FAlbumID[j] = listIDs[j];
				FName[j] = listNames[j];
				
			}			
				  	        	
  	        	
  	        	/*//////////////////////////////////////////// 							    debug 
				List<string> listRespDebug = new List<string>(theResponse.Split(','));   // original response sliced
  	            for (int k = 0; k < (listRespDebug.Count); k++) 						 //  
			    {FName.SliceCount = listRespDebug.Count;
    			FName[k] = listRespDebug[k];}										     // output via Fname pin
  	        	*///////////////////////////////////////////////

  	        	  	        	
  	           } catch (Exception error) {FName[0] = error.Message;} // debug	
		}		
		
		
		
	}
}
